/*
 * Project name:
     Loop.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     23/06/2015
 * Time of creation
     6:59:45 PM
 * Test configuration:
     MCU:             STM32F407ZG
     Dev.Board:       Mikromedia_Plus_for_STM32_ARM
                      http://www.mikroe.com/mikromedia/plus/stm32-m4/
     Oscillator:      25 MHz
     PLL:             120 MHz
     
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
     Application:     This code implements a vehicle detector using an inductive loop in the
                      ground. The loop forms a tuned circuit with a natural oscillatory
                      frequency determined by the electronic components. When a ferromagnetic
                      body (such as a car) comes into proximity of the loop, the oscillator
                      changes frequency slightly. This change is detected and recorded as a
                      vehicle presence. A small hysteresis is added to prevent multiple
                      detections.
 */

#include "Loop_objects.h"
#include "UART6.h"
#include "RGB.h"
#include "Timers.h"
#include "Interrupts.h"




void main() {

     Start_TP();

     UART6_Initialize();
     UART6_PutQueue("Loop program started\r\n");

     RGB_Init();                  // Initialize RGB LED interface
     Timer_Init();                // Initialize timers
     Timer6_Initialize();         // Initialize timer 6

     ExtIntEnable();              // Enable interrupts on PE0

     EnableInterrupts();          // Enable interrupts globally

     while (1) {
    //Check_TP();
     
         UART6_Rx();              // Check for incoming messages
         UART6_CheckQueue();      // Check for outgoing messages
         TimerCheck();            // Check timer pool
         CheckPA0Int();           // Check for external interrupt
         LoopSM();                // Do loop state machine
     }
}