#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Loop_main.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/loop_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct CircleButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircleButton;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int CircleButtonsCount;
 TCircleButton * const code *CircleButtons;
};

extern TScreen Screen1;
extern TImage Image1;
extern TCircleButton CircleButton1;
extern TImage * const code Screen1_Images[1];
extern TCircleButton * const code Screen1_CircleButtons[1];








extern char Image1_Caption[];
extern char CircleButton1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawImage(TImage *AImage);
void DrawCircleButton(TCircleButton *ACircle_button);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/uart6.h"
#line 20 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/rgb.h"
#line 13 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/rgb.h"
void RGB_Init(void);
void RGB_Set_Red(void);
void RGB_Clr_Red(void);
void RGB_Set_Green(void);
void RGB_Clr_Green(void);
void RGB_Set_Blue(void);
void RGB_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
#line 9 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);





void Timer6_Initialize(void);

unsigned int ReadTimer6(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/interrupts.h"
#line 14 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/interrupts.h"
void ExtIntEnable(void);
void CheckPA0Int(void);

void LoopSM(void);
#line 37 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Loop_main.c"
void main() {

 Start_TP();

 UART6_Initialize();
 UART6_PutQueue("Loop program started\r\n");

 RGB_Init();
 Timer_Init();
 Timer6_Initialize();

 ExtIntEnable();

 EnableInterrupts();

 while (1) {


 UART6_Rx();
 UART6_CheckQueue();
 TimerCheck();
 CheckPA0Int();
 LoopSM();
 }
}
