/**************************************************************************************************
  RGB.c
  Support for the red, blue, green LED module.
**************************************************************************************************/

// Include Files
#include "RGB.h"
#include "Buffers.h"



// RGB LED connections
sbit LED_R at GPIOG_ODR.B15;
sbit LED_G at GPIOB_ODR.B3;
sbit LED_B at GPIOB_ODR.B4;




// Variables



/**************************************************************************************************
  RGB_Initialize */
void RGB_Init(void) {
     GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_15);
     GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_3 | _GPIO_PINMASK_4);
}

/**************************************************************************************************
  RGB_Set_Red */
void RGB_Set_Red(void) {
     LED_R = 1;
}

/**************************************************************************************************
  RGB_Clear_Red */
void RGB_Clr_Red(void) {
     LED_R = 0;
}

/**************************************************************************************************
  RGB_Set_Green */
void RGB_Set_Green(void) {
     LED_G = 1;
}

/**************************************************************************************************
  RGB_Clear_Green */
void RGB_Clr_Green(void) {
     LED_G = 0;
}

/**************************************************************************************************
  RGB_Set_Blue */
void RGB_Set_Blue(void) {
     LED_B = 1;
}

/**************************************************************************************************
  RGB_Clear_Blue */
void RGB_Clr_Blue(void) {
     LED_B = 0;
}