_SystemTimerInterrupt:
;Timers.c,22 :: 		void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,23 :: 		if (COUNTFLAG_bit) {              // Interrupts every millisecond
MOVW	R0, #lo_addr(COUNTFLAG_bit+0)
MOVT	R0, #hi_addr(COUNTFLAG_bit+0)
LDR	R1, [R0, #0]
UBFX	R0, R1, BitPos(COUNTFLAG_bit+0), #1
CMP	R0, #0
IT	EQ
BEQ	L_SystemTimerInterrupt0
;Timers.c,24 :: 		irqhandler_timer();           // Service timer pool
BL	_irqhandler_timer+0
;Timers.c,26 :: 		Msec += 1;                    // Increment millisecond counter
MOVW	R2, #lo_addr(_Msec+0)
MOVT	R2, #hi_addr(_Msec+0)
LDRH	R0, [R2, #0]
ADDS	R1, R0, #1
UXTH	R1, R1
STRH	R1, [R2, #0]
;Timers.c,27 :: 		if (Msec > 999) {             // When counter goes to 1000
MOVW	R0, #999
CMP	R1, R0
IT	LS
BLS	L_SystemTimerInterrupt1
;Timers.c,28 :: 		Msec = 0;                 // Set it to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
STRH	R1, [R0, #0]
;Timers.c,29 :: 		TimerFlag = 1;            // Set 1 second flag
MOVS	R1, #1
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,30 :: 		}
L_SystemTimerInterrupt1:
;Timers.c,31 :: 		}
L_SystemTimerInterrupt0:
;Timers.c,32 :: 		}
L_end_SystemTimerInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _SystemTimerInterrupt
_Timer_Init:
;Timers.c,36 :: 		void Timer_Init() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,40 :: 		init_timerpool();                 // Make all timers free
BL	_init_timerpool+0
;Timers.c,42 :: 		clk = Clock_Mhz();
; clk start address is: 0 (R0)
MOVS	R0, #120
;Timers.c,44 :: 		NVIC_SYSTICKRVR = 18750;      // Set reload value register for 150 MHz
L_Timer_Init2:
;Timers.c,45 :: 		else if (clk == 120)
CMP	R0, #120
IT	NE
BNE	L_Timer_Init4
; clk end address is: 0 (R0)
;Timers.c,46 :: 		NVIC_SYSTICKRVR = 15000;      // Set reload value register for 120 MHz
MOVW	R1, #15000
MOVW	R0, #lo_addr(NVIC_SYSTICKRVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKRVR+0)
STR	R1, [R0, #0]
L_Timer_Init4:
;Timers.c,52 :: 		NVIC_SYSTICKCVR = 0;              // Reset timer counter
MOVS	R1, #0
MOVW	R0, #lo_addr(NVIC_SYSTICKCVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKCVR+0)
STR	R1, [R0, #0]
;Timers.c,53 :: 		ENABLE_SYSTICKCSR_bit = 1;        // Enable timer
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(ENABLE_SYSTICKCSR_bit+0)
MOVT	R1, #hi_addr(ENABLE_SYSTICKCSR_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(ENABLE_SYSTICKCSR_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,54 :: 		TICKINT_bit = 1;                  // Enable timer interrupt
MOVW	R1, #lo_addr(TICKINT_bit+0)
MOVT	R1, #hi_addr(TICKINT_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(TICKINT_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,55 :: 		}
L_end_Timer_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer_Init
_TimerCheck:
;Timers.c,59 :: 		void TimerCheck() {
;Timers.c,60 :: 		if (TimerFlag == 1) {
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
LDRSH	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_TimerCheck5
;Timers.c,61 :: 		TimerFlag = 0;                // Reset 1 second flag
MOVS	R1, #0
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,64 :: 		}
L_TimerCheck5:
;Timers.c,65 :: 		}
L_end_TimerCheck:
BX	LR
; end of _TimerCheck
_init_timerpool:
;Timers.c,96 :: 		void init_timerpool(void) {
;Timers.c,99 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_init_timerpool6:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_init_timerpool7
;Timers.c,100 :: 		TimerPool[i].TimerField = 0;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STR	R0, [R1, #0]
;Timers.c,101 :: 		TimerPool[i].Free = TRUE;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;Timers.c,99 :: 		for (i=0; i < NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,102 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_init_timerpool6
L_init_timerpool7:
;Timers.c,103 :: 		}
L_end_init_timerpool:
BX	LR
; end of _init_timerpool
_get_timer:
;Timers.c,111 :: 		unsigned short int get_timer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,114 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_get_timer9:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_get_timer10
;Timers.c,115 :: 		if (TimerPool[i].Free == TRUE) {  // If a free timer is found
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_get_timer12
;Timers.c,116 :: 		TimerPool[i].Free = FALSE;    // Mark it reserved
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #0
STRB	R0, [R1, #0]
;Timers.c,117 :: 		return i;                     // Return timer handle
UXTB	R0, R2
; i end address is: 8 (R2)
IT	AL
BAL	L_end_get_timer
;Timers.c,118 :: 		}
L_get_timer12:
;Timers.c,114 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,119 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_get_timer9
L_get_timer10:
;Timers.c,122 :: 		UART6_PutQueue("TIMERS: No Timers, Resetting..\r\n");
MOVW	R0, #lo_addr(?lstr1_Timers+0)
MOVT	R0, #hi_addr(?lstr1_Timers+0)
BL	_UART6_PutQueue+0
;Timers.c,123 :: 		SystemReset();
BL	_SystemReset+0
;Timers.c,124 :: 		return (0);
MOVS	R0, #0
;Timers.c,125 :: 		}
L_end_get_timer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _get_timer
_free_timer:
;Timers.c,133 :: 		void free_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;Timers.c,134 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #9
IT	LS
BLS	L_free_timer13
; nbr end address is: 0 (R0)
;Timers.c,135 :: 		return;
IT	AL
BAL	L_end_free_timer
L_free_timer13:
;Timers.c,137 :: 		TimerPool[nbr].Free = TRUE;
; nbr start address is: 0 (R0)
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
ADDS	R2, R1, #4
MOVS	R1, #1
STRB	R1, [R2, #0]
;Timers.c,138 :: 		}
L_end_free_timer:
BX	LR
; end of _free_timer
_set_timer:
;Timers.c,147 :: 		void set_timer(unsigned short int nbr, unsigned long int tout) {
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
; tout end address is: 4 (R1)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
; tout start address is: 4 (R1)
;Timers.c,148 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #9
IT	LS
BLS	L_set_timer14
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;Timers.c,149 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer14:
;Timers.c,151 :: 		if (TimerPool[nbr].Free == TRUE)
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
ADDS	R2, R2, #4
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_set_timer15
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;Timers.c,152 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer15:
;Timers.c,154 :: 		TimerPool[nbr].TimerField = tout;
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
; nbr end address is: 0 (R0)
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
STR	R1, [R2, #0]
; tout end address is: 4 (R1)
;Timers.c,155 :: 		}
L_end_set_timer:
BX	LR
; end of _set_timer
_check_timer:
;Timers.c,163 :: 		unsigned long int check_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;Timers.c,164 :: 		return TimerPool[nbr].TimerField;
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
LDR	R1, [R1, #0]
MOV	R0, R1
;Timers.c,165 :: 		}
L_end_check_timer:
BX	LR
; end of _check_timer
_irqhandler_timer:
;Timers.c,173 :: 		void irqhandler_timer(void) {
;Timers.c,176 :: 		for (i=0; i<NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_irqhandler_timer16:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_irqhandler_timer17
;Timers.c,177 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__irqhandler_timer24
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L__irqhandler_timer23
L__irqhandler_timer22:
;Timers.c,178 :: 		TimerPool[i].TimerField--;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;Timers.c,177 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
L__irqhandler_timer24:
L__irqhandler_timer23:
;Timers.c,176 :: 		for (i=0; i<NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,179 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_irqhandler_timer16
L_irqhandler_timer17:
;Timers.c,180 :: 		}
L_end_irqhandler_timer:
BX	LR
; end of _irqhandler_timer
_Timer6_Initialize:
;Timers.c,200 :: 		void Timer6_Initialize(void) {
;Timers.c,202 :: 		TIM6EN_bit = 1;              // Enable TIM6 clock in RCC_APB1ENR
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(TIM6EN_bit+0)
MOVT	R0, #hi_addr(TIM6EN_bit+0)
STR	R2, [R0, #0]
;Timers.c,203 :: 		TIM6_PSC = 5;                // Set the prescaler register to 5 (5 + 1 = divide by 6)
MOVS	R1, #5
MOVW	R0, #lo_addr(TIM6_PSC+0)
MOVT	R0, #hi_addr(TIM6_PSC+0)
STR	R1, [R0, #0]
;Timers.c,205 :: 		CEN_TIM6_CR1_bit = 1;        // Enable counter in TIM6_CR1
MOVW	R0, #lo_addr(CEN_TIM6_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM6_CR1_bit+0)
STR	R2, [R0, #0]
;Timers.c,207 :: 		}
L_end_Timer6_Initialize:
BX	LR
; end of _Timer6_Initialize
_ReadTimer6:
;Timers.c,212 :: 		unsigned int ReadTimer6(void) {
;Timers.c,213 :: 		return TIM6_CNT;
MOVW	R0, #lo_addr(TIM6_CNT+0)
MOVT	R0, #hi_addr(TIM6_CNT+0)
LDR	R0, [R0, #0]
;Timers.c,214 :: 		}
L_end_ReadTimer6:
BX	LR
; end of _ReadTimer6
