_UART6_Interrupt:
;UART6.c,66 :: 		void UART6_Interrupt() iv IVT_INT_USART6 ics ICS_AUTO {
;UART6.c,71 :: 		if ((RXNE_USART6_SR_bit) /* || (ORE_bit) */ ) {
MOVW	R1, #lo_addr(RXNE_USART6_SR_bit+0)
MOVT	R1, #hi_addr(RXNE_USART6_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Interrupt0
;UART6.c,72 :: 		R_data = USART6_DR;           // Fetch a byte from receive register
MOVW	R0, #lo_addr(USART6_DR+0)
MOVT	R0, #hi_addr(USART6_DR+0)
; R_data start address is: 12 (R3)
LDR	R3, [R0, #0]
;UART6.c,73 :: 		RxQueue[RxIn++] = R_data;     // Put data byte in re-circulating buffer, increment pointer
MOVW	R2, #lo_addr(_RxIn+0)
MOVT	R2, #hi_addr(_RxIn+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RxQueue+0)
MOVT	R0, #hi_addr(_RxQueue+0)
ADDS	R0, R0, R1
STRB	R3, [R0, #0]
; R_data end address is: 12 (R3)
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R2, #0]
;UART6.c,74 :: 		if (RxIn > (rxqsize-1))       // Adjust pointer if necessary
CMP	R0, #255
IT	LS
BLS	L_UART6_Interrupt1
;UART6.c,75 :: 		RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
L_UART6_Interrupt1:
;UART6.c,76 :: 		}
L_UART6_Interrupt0:
;UART6.c,78 :: 		if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
MOVW	R1, #lo_addr(TXE_USART6_SR_bit+0)
MOVT	R1, #hi_addr(TXE_USART6_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART6_Interrupt52
MOVW	R1, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART6_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART6_Interrupt51
L__UART6_Interrupt50:
;UART6.c,79 :: 		T_data = XmtBuf[XmtBufPtr++]; // Get a byte from the transmit buffer
MOVW	R2, #lo_addr(_XmtBufPtr+0)
MOVT	R2, #hi_addr(_XmtBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_XmtBuf+0)
MOVT	R0, #hi_addr(_XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
; T_data start address is: 12 (R3)
UXTB	R3, R1
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART6.c,80 :: 		if (T_data == NUL) {          // If it is the end of message marker
CMP	R1, #0
IT	NE
BNE	L_UART6_Interrupt5
; T_data end address is: 12 (R3)
;UART6.c,81 :: 		TXEIE_USART6_CR1_bit = 0; // Disable transmitter interrupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,82 :: 		} else {
IT	AL
BAL	L_UART6_Interrupt6
L_UART6_Interrupt5:
;UART6.c,83 :: 		USART6_DR = T_data;       // Transfer data byte to transmit register
; T_data start address is: 12 (R3)
MOVW	R0, #lo_addr(USART6_DR+0)
MOVT	R0, #hi_addr(USART6_DR+0)
STR	R3, [R0, #0]
; T_data end address is: 12 (R3)
;UART6.c,84 :: 		}
L_UART6_Interrupt6:
;UART6.c,78 :: 		if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
L__UART6_Interrupt52:
L__UART6_Interrupt51:
;UART6.c,86 :: 		}
L_end_UART6_Interrupt:
BX	LR
; end of _UART6_Interrupt
_UART6_SetBaud:
;UART6.c,90 :: 		void UART6_SetBaud(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,99 :: 		&_GPIO_MODULE_USART6_PC67);
MOVW	R0, #lo_addr(__GPIO_MODULE_USART6_PC67+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART6_PC67+0)
PUSH	(R0)
;UART6.c,98 :: 		UART6_Init_Advanced(9600,_UART_8_BIT_DATA,_UART_NOPARITY,_UART_ONE_STOPBIT,
MOVW	R3, #0
MOVW	R2, #0
MOVW	R1, #0
MOVW	R0, #9600
;UART6.c,99 :: 		&_GPIO_MODULE_USART6_PC67);
BL	_UART6_Init_Advanced+0
ADD	SP, SP, #4
;UART6.c,116 :: 		NVIC_IntEnable(IVT_INT_USART6);   // Enable interrupt vector (always required)
MOVW	R0, #87
BL	_NVIC_IntEnable+0
;UART6.c,118 :: 		}
L_end_UART6_SetBaud:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_SetBaud
_UART6_StartRx:
;UART6.c,122 :: 		void UART6_StartRx(void) {
;UART6.c,123 :: 		RXNEIE_USART6_CR1_bit = 1;        // Interrupt when receive buffer is full (RXNE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(RXNEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,124 :: 		}
L_end_UART6_StartRx:
BX	LR
; end of _UART6_StartRx
_UART6_StartTx:
;UART6.c,128 :: 		void UART6_StartTx(void) {
;UART6.c,129 :: 		TXEIE_USART6_CR1_bit = 1;         // Interrupt when transmit buffer is empty (TXE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,130 :: 		}
L_end_UART6_StartTx:
BX	LR
; end of _UART6_StartTx
_UART6_Initialize:
;UART6.c,139 :: 		void UART6_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,140 :: 		UART6_RxQueueInit();
BL	_UART6_RxQueueInit+0
;UART6.c,141 :: 		UART6_TxQueueInit();
BL	_UART6_TxQueueInit+0
;UART6.c,143 :: 		UART6_SetBaud();
BL	_UART6_SetBaud+0
;UART6.c,144 :: 		UART6_StartRx();
BL	_UART6_StartRx+0
;UART6.c,145 :: 		}
L_end_UART6_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_Initialize
_UART6_RxQueueInit:
;UART6.c,150 :: 		void UART6_RxQueueInit(void) {
;UART6.c,151 :: 		RxIn = RxOut = 0;                 // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxOut+0)
MOVT	R0, #hi_addr(_RxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
;UART6.c,152 :: 		RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
STRB	R1, [R0, #0]
;UART6.c,153 :: 		}
L_end_UART6_RxQueueInit:
BX	LR
; end of _UART6_RxQueueInit
_UART6_GetChar:
;UART6.c,159 :: 		char UART6_GetChar(char *rxbyte) {
; rxbyte start address is: 0 (R0)
; rxbyte end address is: 0 (R0)
; rxbyte start address is: 0 (R0)
;UART6.c,160 :: 		if (RxIn != RxOut) {              // If there is a character in the buffer
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(_RxIn+0)
MOVT	R1, #hi_addr(_RxIn+0)
LDRB	R1, [R1, #0]
CMP	R1, R2
IT	EQ
BEQ	L_UART6_GetChar7
;UART6.c,161 :: 		*rxbyte = RxQueue[RxOut++];    // Extract the character and update the pointer
MOVW	R3, #lo_addr(_RxOut+0)
MOVT	R3, #hi_addr(_RxOut+0)
LDRB	R2, [R3, #0]
MOVW	R1, #lo_addr(_RxQueue+0)
MOVT	R1, #hi_addr(_RxQueue+0)
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
; rxbyte end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART6.c,162 :: 		if (RxOut > (rxqsize-1))       // Check for wrap
CMP	R1, #255
IT	LS
BLS	L_UART6_GetChar8
;UART6.c,163 :: 		RxOut = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
STRB	R2, [R1, #0]
L_UART6_GetChar8:
;UART6.c,164 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_UART6_GetChar
;UART6.c,165 :: 		}else{
L_UART6_GetChar7:
;UART6.c,166 :: 		return 0;                      // No data available
MOVS	R0, #0
;UART6.c,168 :: 		}
L_end_UART6_GetChar:
BX	LR
; end of _UART6_GetChar
_UART6_Rx:
;UART6.c,172 :: 		void UART6_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,173 :: 		UART6_RxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R4, #hi_addr(_UART6_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART6.c,174 :: 		}
L_end_UART6_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_Rx
_UART6_Rx1:
;UART6.c,179 :: 		void UART6_Rx1(void){
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART6.c,182 :: 		if (UART6_GetChar(&rxchar)) {
ADD	R0, SP, #4
BL	_UART6_GetChar+0
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Rx110
;UART6.c,183 :: 		switch (rxchar) {
IT	AL
BAL	L_UART6_Rx111
;UART6.c,184 :: 		case NUL:         // Discard NUL character
L_UART6_Rx113:
;UART6.c,185 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,187 :: 		case '\r':        // Discard return character
L_UART6_Rx114:
;UART6.c,188 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,190 :: 		case '\n':
L_UART6_Rx115:
;UART6.c,191 :: 		RcvBuf[RcvBufPtr++] = rxchar;       // Put received character into buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART6.c,192 :: 		RcvBuf[RcvBufPtr] = 0;              // End marker
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART6.c,193 :: 		RcvBufPtr = 0;                      // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART6.c,194 :: 		UART6_RxFuncPtr = UART6_Rx2;        // Go to state 2
MOVW	R1, #lo_addr(_UART6_Rx2+0)
MOVT	R1, #hi_addr(_UART6_Rx2+0)
MOVW	R0, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART6_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART6.c,195 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,197 :: 		default:
L_UART6_Rx116:
;UART6.c,198 :: 		if (RcvBufPtr < (RcvBufSize-2))     // Prevents buffer overrun
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	CS
BCS	L_UART6_Rx117
;UART6.c,199 :: 		RcvBuf[RcvBufPtr++] = rxchar;   // Put character in buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
L_UART6_Rx117:
;UART6.c,200 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,201 :: 		}
L_UART6_Rx111:
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Rx113
LDRB	R0, [SP, #4]
CMP	R0, #13
IT	EQ
BEQ	L_UART6_Rx114
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	EQ
BEQ	L_UART6_Rx115
IT	AL
BAL	L_UART6_Rx116
L_UART6_Rx112:
;UART6.c,202 :: 		}
L_UART6_Rx110:
;UART6.c,203 :: 		}
L_end_UART6_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART6_Rx1
_UART6_Rx2:
;UART6.c,208 :: 		void UART6_Rx2(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART6.c,213 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART6_Rx218
;UART6.c,217 :: 		case 'a': // Diagnostic
L_UART6_Rx220:
;UART6.c,218 :: 		UART6_PutQueue("Command 'a' received\r\n");
MOVW	R0, #lo_addr(?lstr1_UART6+0)
MOVT	R0, #hi_addr(?lstr1_UART6+0)
BL	_UART6_PutQueue+0
;UART6.c,219 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,221 :: 		case 'b': // Display Timer6 free-running counter
L_UART6_Rx221:
;UART6.c,222 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,223 :: 		sprintf(BufNum,"Timer6: %04X\r\n",TIM6_CNT);
MOVW	R1, #lo_addr(TIM6_CNT+0)
MOVT	R1, #hi_addr(TIM6_CNT+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_2_UART6+0)
MOVT	R1, #hi_addr(?lstr_2_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,224 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,225 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,227 :: 		case 'c': // Display the sum value
L_UART6_Rx222:
;UART6.c,228 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,229 :: 		sprintf(BufNum,"Sum value: %08LX\r\n",Sum);
MOVW	R1, #lo_addr(_Sum+0)
MOVT	R1, #hi_addr(_Sum+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_3_UART6+0)
MOVT	R1, #hi_addr(?lstr_3_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,230 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,231 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,233 :: 		case 'd': // Display the average value
L_UART6_Rx223:
;UART6.c,234 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,235 :: 		sprintf(BufNum,"Average value: %04X\r\n",Average);
MOVW	R1, #lo_addr(_Average+0)
MOVT	R1, #hi_addr(_Average+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_4_UART6+0)
MOVT	R1, #hi_addr(?lstr_4_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,236 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,237 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,239 :: 		case 'e': // Display the MPU PLL frequency
L_UART6_Rx224:
;UART6.c,240 :: 		clk = Clock_Mhz();
; clk start address is: 4 (R1)
MOVS	R1, #120
;UART6.c,241 :: 		BufNum = GetBuffer();
STRH	R1, [SP, #4]
BL	_GetBuffer+0
LDRH	R1, [SP, #4]
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,242 :: 		sprintf(BufNum,"Clock: %d\r\n",clk);
UXTH	R2, R1
; clk end address is: 4 (R1)
MOVW	R1, #lo_addr(?lstr_5_UART6+0)
MOVT	R1, #hi_addr(?lstr_5_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,243 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,244 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,246 :: 		case 'f': // Display the state machine state number
L_UART6_Rx225:
;UART6.c,247 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,248 :: 		sprintf(BufNum,"State: %d\r\n",LoopState);
MOVW	R1, #lo_addr(_LoopState+0)
MOVT	R1, #hi_addr(_LoopState+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_6_UART6+0)
MOVT	R1, #hi_addr(?lstr_6_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,249 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,250 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,252 :: 		case 'g': // Display assigned lower threshold
L_UART6_Rx226:
;UART6.c,253 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,254 :: 		sprintf(BufNum,"Lower threshold: %04X\r\n",LowThresh);
MOVW	R1, #lo_addr(_LowThresh+0)
MOVT	R1, #hi_addr(_LowThresh+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_7_UART6+0)
MOVT	R1, #hi_addr(?lstr_7_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,255 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,256 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,258 :: 		case 'h': // Display assigned upper threshold
L_UART6_Rx227:
;UART6.c,259 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,260 :: 		sprintf(BufNum,"Upper threshold: %04X\r\n",HighThresh);
MOVW	R1, #lo_addr(_HighThresh+0)
MOVT	R1, #hi_addr(_HighThresh+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_8_UART6+0)
MOVT	R1, #hi_addr(?lstr_8_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,261 :: 		UART6_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,262 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,264 :: 		case 'i': // Force-tune the loop and set thresholds
L_UART6_Rx228:
;UART6.c,265 :: 		LoopState = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
STRB	R1, [R0, #0]
;UART6.c,266 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,268 :: 		case 'j': // Display frequency of loop oscillator
L_UART6_Rx229:
;UART6.c,269 :: 		Frequency = 1 / (Average * 0.000000001);
MOVW	R0, #lo_addr(_Average+0)
MOVT	R0, #hi_addr(_Average+0)
LDRH	R0, [R0, #0]
VMOV	S1, R0
VCVT.F32	#0, S1, S1
MOVW	R0, #28767
MOVT	R0, #12425
VMOV	S0, R0
VMUL.F32	S1, S1, S0
VMOV.F32	S0, #1
VDIV.F32	S0, S0, S1
; Frequency start address is: 4 (R1)
VMOV.F32	S1, S0
;UART6.c,270 :: 		BufNum = GetBuffer();
VSTR	#1, S1, [SP, #4]
BL	_GetBuffer+0
VLDR	#1, S1, [SP, #4]
; BufNum start address is: 8 (R2)
MOV	R2, R0
;UART6.c,271 :: 		sprintf(BufNum,"Loop oscillator frequency: %5.2f Hz\r\n",Frequency);
VMOV.F32	S0, S1
; Frequency end address is: 4 (R1)
MOVW	R1, #lo_addr(?lstr_9_UART6+0)
MOVT	R1, #hi_addr(?lstr_9_UART6+0)
STR	R2, [SP, #4]
VPUSH	#0, (S0)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R2, [SP, #4]
;UART6.c,272 :: 		UART6_PutQueue(BufNum);
MOV	R0, R2
; BufNum end address is: 8 (R2)
BL	_UART6_PutQueue+0
;UART6.c,273 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,275 :: 		case 'k':
L_UART6_Rx230:
;UART6.c,276 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,278 :: 		case 'l':
L_UART6_Rx231:
;UART6.c,279 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,281 :: 		case 'm':
L_UART6_Rx232:
;UART6.c,282 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,284 :: 		case 'n':
L_UART6_Rx233:
;UART6.c,285 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,287 :: 		case 'o':
L_UART6_Rx234:
;UART6.c,288 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,290 :: 		case 'p':
L_UART6_Rx235:
;UART6.c,291 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,293 :: 		case 'r':
L_UART6_Rx236:
;UART6.c,294 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,296 :: 		case 's':
L_UART6_Rx237:
;UART6.c,297 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,299 :: 		case 't':
L_UART6_Rx238:
;UART6.c,300 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,302 :: 		case 'u':
L_UART6_Rx239:
;UART6.c,303 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,305 :: 		case 'v':
L_UART6_Rx240:
;UART6.c,306 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,308 :: 		case 'w':
L_UART6_Rx241:
;UART6.c,309 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,311 :: 		case 'x':
L_UART6_Rx242:
;UART6.c,312 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,314 :: 		case 'y':
L_UART6_Rx243:
;UART6.c,315 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,317 :: 		case 'z':
L_UART6_Rx244:
;UART6.c,318 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,321 :: 		default:
L_UART6_Rx245:
;UART6.c,322 :: 		UART6_PutQueue("Unknown command: ");
MOVW	R0, #lo_addr(?lstr10_UART6+0)
MOVT	R0, #hi_addr(?lstr10_UART6+0)
BL	_UART6_PutQueue+0
;UART6.c,324 :: 		BufNum = GetBuffer();                // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,325 :: 		(void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_11_UART6+0)
MOVT	R1, #hi_addr(?lstr_11_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,326 :: 		UART6_PutQueue(BufNum);              // Send the message
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,327 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,328 :: 		}
L_UART6_Rx218:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_UART6_Rx220
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_UART6_Rx221
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_UART6_Rx222
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_UART6_Rx223
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_UART6_Rx224
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_UART6_Rx225
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_UART6_Rx226
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_UART6_Rx227
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_UART6_Rx228
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_UART6_Rx229
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_UART6_Rx230
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_UART6_Rx231
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_UART6_Rx232
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_UART6_Rx233
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_UART6_Rx234
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_UART6_Rx235
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_UART6_Rx236
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_UART6_Rx237
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_UART6_Rx238
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_UART6_Rx239
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_UART6_Rx240
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_UART6_Rx241
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_UART6_Rx242
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_UART6_Rx243
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_UART6_Rx244
IT	AL
BAL	L_UART6_Rx245
L_UART6_Rx219:
;UART6.c,329 :: 		UART6_RxFuncPtr = UART6_Rx1;               // Go back to state 1
MOVW	R1, #lo_addr(_UART6_Rx1+0)
MOVT	R1, #hi_addr(_UART6_Rx1+0)
MOVW	R0, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART6_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART6.c,330 :: 		}
L_end_UART6_Rx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART6_Rx2
_UART6_TxQueueInit:
;UART6.c,337 :: 		void UART6_TxQueueInit(void) {
;UART6.c,338 :: 		TxIn = TxOut = 0;         // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
STRB	R1, [R0, #0]
;UART6.c,339 :: 		XmtBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
STRB	R1, [R0, #0]
;UART6.c,340 :: 		}
L_end_UART6_TxQueueInit:
BX	LR
; end of _UART6_TxQueueInit
_UART6_PutQueue:
;UART6.c,345 :: 		void UART6_PutQueue(char *msg) {
; msg start address is: 0 (R0)
; msg end address is: 0 (R0)
; msg start address is: 0 (R0)
;UART6.c,346 :: 		TxQueue[TxIn++] = msg;    // Put the message pointer into FIFO
MOVW	R3, #lo_addr(_TxIn+0)
MOVT	R3, #hi_addr(_TxIn+0)
LDRB	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_TxQueue+0)
MOVT	R1, #hi_addr(_TxQueue+0)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
; msg end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R2, R1, #1
UXTB	R2, R2
STRB	R2, [R3, #0]
;UART6.c,347 :: 		if (TxIn > (txqsize-1))   // Adjust FIFO in pointer
MOVW	R1, #1023
CMP	R2, R1
IT	LE
BLE	L_UART6_PutQueue46
;UART6.c,348 :: 		TxIn = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_TxIn+0)
MOVT	R1, #hi_addr(_TxIn+0)
STRB	R2, [R1, #0]
L_UART6_PutQueue46:
;UART6.c,349 :: 		}
L_end_UART6_PutQueue:
BX	LR
; end of _UART6_PutQueue
_UART6_SendMsg:
;UART6.c,353 :: 		void UART6_SendMsg(char *s) {
; s start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; s end address is: 0 (R0)
; s start address is: 0 (R0)
;UART6.c,354 :: 		XmtBuf = s;               // Pointer to the message for the interrupt handler
MOVW	R1, #lo_addr(_XmtBuf+0)
MOVT	R1, #hi_addr(_XmtBuf+0)
STR	R0, [R1, #0]
; s end address is: 0 (R0)
;UART6.c,355 :: 		XmtBufPtr = 0;            // Set character counter to start of text message
MOVS	R2, #0
MOVW	R1, #lo_addr(_XmtBufPtr+0)
MOVT	R1, #hi_addr(_XmtBufPtr+0)
STRB	R2, [R1, #0]
;UART6.c,356 :: 		UART6_StartTx();          // Turn on the transmitter
BL	_UART6_StartTx+0
;UART6.c,357 :: 		}
L_end_UART6_SendMsg:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_SendMsg
_UART6_CheckQueue:
;UART6.c,362 :: 		void UART6_CheckQueue(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,363 :: 		if (TXEIE_USART6_CR1_bit == 0) {   // Don't try to start transmitter if already transmitting
MOVW	R1, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART6_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_UART6_CheckQueue47
;UART6.c,364 :: 		if (TxIn != TxOut) {                 // If pointers are not the same
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_UART6_CheckQueue48
;UART6.c,365 :: 		UART6_SendMsg(TxQueue[TxOut++]); // Hand off the message pointer and increment counter
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_TxQueue+0)
MOVT	R0, #hi_addr(_TxQueue+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
BL	_UART6_SendMsg+0
MOVW	R2, #lo_addr(_TxOut+0)
MOVT	R2, #hi_addr(_TxOut+0)
LDRB	R0, [R2, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART6.c,366 :: 		if (TxOut > (txqsize-1))         // Check for wrap
MOVW	R0, #1023
CMP	R1, R0
IT	LE
BLE	L_UART6_CheckQueue49
;UART6.c,367 :: 		TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
L_UART6_CheckQueue49:
;UART6.c,368 :: 		}
L_UART6_CheckQueue48:
;UART6.c,369 :: 		}
L_UART6_CheckQueue47:
;UART6.c,370 :: 		}
L_end_UART6_CheckQueue:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_CheckQueue
